--Toy Guard por Francisco Muoz Cuevas

-- Imagenes
Explicacion = Image.load("IMG/Entrada.png")
Portada = Image.load("IMG/Principal.png")
Escenario = Image.load("IMG/Escenario.png")
Selec = Image.load("IMG/Select.png")
GameOver = Image.load("IMG/gameover.png")
Blanco = Color.new(255,255,255)
Verde = Color.new(0,255,0)
Rojo = Color.new(255,0,0)
--Juego
Juego = {Estado = 1, Puntuacion = 0, PSiguienteNivel = 0,NJuguetes = 5, Velocidad = 1, Nivel = 0,JugueteSelec = 0, Negligencias = 0}
Font = Font.load("FONT/Verdana.ttf")
Font:setPixelSizes(0,20)
--Juguetes
TileIMG = {Image.load("IMG/peluche.png"),Image.load("IMG/cuchillos.png"),Image.load("IMG/pistola.png"),Image.load("IMG/Girafa.png"),Image.load("IMG/Jeringa.png"),Image.load("IMG/playmobil.png"),Image.load("IMG/Peluche2.png") }
Tipo = {1,2,2,3,2,1,1}

function IniciarJuguetes()
OldJuguete = 5
Juguete = {}
Juguete[1] = {x = 340, y = 130, Tile = 1,Tipo = 1}
Juguete[2] = {x = 340+130, y = 130, Tile = 1,Tipo = 1}
Juguete[3] = {x = 340+2*130, y = 130, Tile = 2,Tipo = 2}
Juguete[4] = {x = 340+3*130, y = 130, Tile = 6,Tipo = 6}
Juguete[5] = {x = 340+4*130, y = 130, Tile = 4,Tipo = 4}
end

--funciones
function Interfaz()
if pad:start() and oldpad:start() ~= pad:start() then
   Juego.Estado = 5
   oldpad = pad
   while Juego.Estado == 5 do
       pad = Controls.read()
       screen:clear()
       Font:setPixelSizes(0,20)
       screen:fontPrint(Font,70,50,"Menu Pausa",Blanco)
       screen:fontPrint(Font,80,80,"Pulse x para volver al juego",Blanco)
       screen:fontPrint(Font,80,110,"Pulse O para salir del juego",Blanco) 
       screen:fontPrint(Font,70,150,"Instrucciones:", Blanco)
       Font:setPixelSizes(0,15)
       screen:fontPrint(Font,80,170,"Pulsa [] para retirar juguetes defectuosos.",Blanco)
       screen:fontPrint(Font,80,190,"Pulsa X para retirar juguetes peligrosos.",Blanco)
       screen:fontPrint(Font,80,210,"Cometer mas de 5 negligencias es motivo de despido.",Blanco)      
       if pad:circle()  and oldpad:circle() ~= pad:circle() then
          Juego.Estado = 4
       end
       if pad:cross()  and oldpad:cross() ~= pad:cross() then
          Juego.Estado = 3
       end
   screen.flip()
   screen.waitVblankStart()
   oldpad = pad 
   end
end
screen:print(20,20,"Puntuacion: "..Juego.Puntuacion,Blanco)
screen:print(20,40,"Negligencias: "..Juego.Negligencias,Blanco)
screen:print(20,60, "Puntos para Siguiente: " .. 200-Juego.PSiguienteNivel,Blanco)
end--Fuin funcion interfaz

function GestionJuguetes()
for n = 1, Juego.NJuguetes do
 if Juguete[n] ~= nil then
    if Juguete[n].x < 310 then
       screen:blit(Juguete[n].x,Juguete[n].y,TileIMG[Juguete[n].Tile])
    end
    Juguete[n].x = Juguete[n].x - Juego.Velocidad
    if Juguete[n]. x > 160 and Juguete[n].x + 70 < 275 then
       Juego.JugueteSelec = n
    end 
    if Juguete[n].x + 70 < 0 then
       if Juguete[n].Tipo == 2 then
          Juego.Puntuacion = Juego.Puntuacion - 10
          Juego.PSiguienteNivel = Juego.PSiguienteNivel - 5
          Juego.Negligencias = Juego.Negligencias + 1
       elseif Juguete[n].Tipo == 3 then
          Juego.Puntuacion = Juego.Puntuacion - 10
          Juego.PSiguienteNivel = Juego.PSiguienteNivel - 5
          Juego.Negligencias = Juego.Negligencias + 1
       elseif Juguete[n].Tipo == 1 then
          Juego.Puntuacion = Juego.Puntuacion + 10
          Juego.PSiguienteNivel = Juego.PSiguienteNivel + 10
       end
       Juguete[n] = nil
       CrearJugutes(n)
    end
 end
end
end

function CrearJugutes(N)
math.randomseed(Juego.Puntuacion+Juego.PSiguienteNivel)
Juguete[N] = {x = Juguete[OldJuguete].x+130, y = 130, Tile = math.random(1,7), Tipo = 1}
Juguete[N].Tipo = Tipo[Juguete[N].Tile]
OldJuguete = N
end

function CambioNivel()
if Juego.PSiguienteNivel >= 200 then
   Juego.PSiguienteNivel = 0
   Juego.Nivel = Juego.Nivel + 1
   Juego.Velocidad = Juego.Velocidad + 0.5
   Juego.Negligencias = 0
end
end
--bucle infinito
while true do

--Si estamos en la presentacion
while Juego.Estado == 1 do
pad = Controls.read()

screen:clear()
screen:blit(0,0,Explicacion)
Font:setPixelSizes(0,15)
screen:fontPrint(Font,300,250,"Pulse X",Blanco)
if pad:cross() then
   Juego.Estado = 2
end

screen.flip()
screen.waitVblankStart()
oldpad = pad
end

--Si estamos en la portada
while Juego.Estado == 2 do
pad = Controls.read()

screen:clear()
screen:blit(0,0,Portada)

if pad:start() then
   Juego.Estado = 3
IniciarJuguetes()
end

screen.flip()
screen.waitVblankStart()
oldpad = pad
end

--Si estamos en el juego
while Juego.Estado == 3 do
pad = Controls.read()
Juego.JugueteSelec = 0

GestionJuguetes()
screen:clear()
screen:blit(0,0,Escenario)
screen:blit(180,120,Selec)

GestionJuguetes()
Interfaz()
if Juego.JugueteSelec > 0 then
if pad:cross() and oldpad:cross() ~= pad:cross() then
   if Juguete[Juego.JugueteSelec].Tipo == 2 then
      Juguete[Juego.JugueteSelec].Tipo = 1
      screen:print(240,110, "+10", Verde)
   else
      Juego.Puntuacion = Juego.Puntuacion - 10
      Juego.PSiguienteNivel = Juego.PSiguienteNivel - 5
      Juego.Negligencias = Juego.Negligencias + 1
      screen:print(240,110, "-5", Rojo)
   end
end

CambioNivel()
if pad:square() and oldpad:square() ~= pad:square() then
   if Juguete[Juego.JugueteSelec].Tipo == 3 then
      Juguete[Juego.JugueteSelec].Tipo = 1
      screen:print(240,110, "+10", Verde)
   else
      Juego.Puntuacion = Juego.Puntuacion - 10
      Juego.PSiguienteNivel = Juego.PSiguienteNivel - 5
      Juego.Negligencias = Juego.Negligencias + 1
      screen:print(240,110, "-5", Rojo)
   end
end
end

if Juego.Negligencias > 5 then
   Juego.Estado = 4
end

screen.flip()
screen.waitVblankStart()
oldpad = pad
end
-- Si estamos en la pantalla de GameOver

while Juego.Estado == 4 do
pad = Controls.read()
screen:clear()
screen:blit(0,0,GameOver)

if pad:circle() and oldpad:circle() ~= pad:circle() then
   Juego.Estado = 2
   Juego.Puntuacion = 0
   Juego.Nivel = 0
   Juego.Negligencias = 0
   Juego.PSiguienteNivel = 0
   Juego.Velocidad = 1
end

 Font:setPixelSizes(0,30)
 screen:fontPrint(Font,200,180,Juego.Puntuacion, Blanco)
 Font:setPixelSizes(0,15)
 screen:fontPrint(Font,90,220,"Pulsa O para volver al menu principal",Blanco)
screen.flip()
screen.waitVblankStart()
oldpad = pad
end

end

